/*** * **** * ***** ********* ** ****** ***** *** ***** ********
**
** Copyright (c) 2005-2010, SkeTo Project
** All rights reserved.
**
** This file is part of the SkeTo Library. This library is free
** software; you can redistribute it and/or modify it under the
** terms of the MIT License (see COPYING in the package).
** 
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
**
*** * **** * ***** ********* ** ****** ***** *** ***** ********/

/**
 *
 * @file matrix_skeletons_predef.h
 * @brief A set of predefinition of class names, etc.
 */
#ifndef __DIST_MATRIX_PREDEF_H__
#define __DIST_MATRIX_PREDEF_H__

namespace sketo {
  template <typename A> class dist_matrix;

  namespace _impl {
    template <typename A> class dist_matrix_buffer;

    enum {
      TAG_REDUCE,
      TAG_SCAN1,
      TAG_PRINT,
      TAG_SHIFT,
      TAG_SHIFT_RESERVE1,
      TAG_SHIFT_RESERVE2,
      TAG_SHIFT_RESERVE3,
      TAG_SHIFT_RESERVE4,
      TAG_GATHER,
    };
    
    class ms_adpt;
  }

}




#endif // __DIST_MATRIX_PREDEF_H__
