/*** * **** * ***** ********* ** ****** ***** *** ***** ********
**
** Copyright (c) 2005-2010, SkeTo Project
** All rights reserved.
**
** This file is part of the SkeTo Library. This library is free
** software; you can redistribute it and/or modify it under the
** terms of the MIT License (see COPYING in the package).
** 
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
**
*** * **** * ***** ********* ** ****** ***** *** ***** ********/

/**
 * @file exceptions.h
 * @brief The header for exceptions.
 * @author Yoshiki AKASHI, Kiminori Matsuzaki
 */

#ifndef __EXCEPTIONS_H__
#define __EXCEPTIONS_H__

#include <string>

namespace sketo {
  namespace exception {
  }
}

#endif // __EXCEPTIONS_H__

////////////////////////////////////////////////////////////////////////
#if 0 // An old version
    struct bad_size {
      int size_a;
      int size_b;
      bad_size(int a, int b)
	: size_a(a), size_b(b) { }
    };

    struct error {
      int _errno;
      std::string msg;
      error(int errno_ = -1, std::string msg_ = std::string(""))
	: _errno(errno_), msg(msg_) { }
    };
#endif
