/*** * **** * ***** ********* ** ****** ***** *** ***** ********
**
** Copyright (c) 2005-2010, SkeTo Project
** All rights reserved.
**
** This file is part of the SkeTo Library. This library is free
** software; you can redistribute it and/or modify it under the
** terms of the MIT License (see COPYING in the package).
** 
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
**
*** * **** * ***** ********* ** ****** ***** *** ***** ********/

/**
 * @flie matrix_skeletons.h
 * @brief The main file for distributed matrices and matrix skeletons.
 */

#ifndef __MATRIX_SKELETONS_H__
#define __MATRIX_SKELETONS_H__

//#define __SKETO_NO_FUSION__

#include "sketo.h"

#include "dist_matrix.h"

#include "matrix_skeletons_predef.h"

#ifdef __SKETO_NO_FUSION__
#include "matrix_skeletons_noopt.h"
#else
#include "matrix_skeletons_with_fusion.h"
#endif

#endif // __MATRIX_SKELETONS_H__

