/*** * **** * ***** ********* ** ****** ***** *** ***** ********
**
** Copyright (c) 2005-2010, SkeTo Project
** All rights reserved.
**
** This file is part of the SkeTo Library. This library is free
** software; you can redistribute it and/or modify it under the
** terms of the MIT License (see COPYING in the package).
** 
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
**
*** * **** * ***** ********* ** ****** ***** *** ***** ********/

/**
 * @file sketo_time.h
 * @brief Some utility functions about mesuring execution time.
 * @author Kiminori MATSUAZKI, Kento EMOTO
 */

#ifndef __SKETO_TIME_H__
#define __SKETO_TIME_H__

namespace sketo {

  namespace time {
    void initialize();
    void set_time(const char* name, bool barrier = true);
    void print(FILE *fp = stdout);
  };

}

#endif // __SKETO_TIME_H__
